=== modified file '.bzrignore'
--- .bzrignore	2010-04-22 08:52:59 +0000
+++ .bzrignore	2010-03-23 15:44:51 +0000
@@ -7,5 +7,5 @@
 *.log
 _trial_temp
 loggerhead-memprofile
-./docs/_build/
-tags
+docs/_build/doctrees
+docs/_build/html

=== modified file 'NEWS'
--- NEWS	2011-03-24 03:40:33 +0000
+++ NEWS	2010-02-26 04:38:23 +0000
@@ -1,26 +1,8 @@
 What's changed in loggerhead?
 =============================
 
-1.18.1 [24Mar2011]
-------------------
-
-    - Fix escaping of filenames in revision views.
-      (William Grant, #740142)
-
-    - Add missing import to loggerhead.trace, allowing start-loggerhead
-      to run when a log.roll config option is set.
-      (Max Kanat-Alexander, #673999)
-
-
-1.18 [10Nov2010]
-----------------
-
-    - Syntax highlighting is no longer applied for files greater than 512K,
-      reducing codebrowse.launchpad.net overloading.
-      (Max Kanat-Alexander, #513044)
-
-    - Documentation added in the docs directory. README simplified
-      accordingly. (Tres Seaver).
+dev [future]
+------------
 
     - Show svn/git/hg revision ids in loggerhead revision view.
       (Jelmer Vernooij)
@@ -33,21 +15,8 @@
     - Repository.get_revision_inventory() was removed in bzr 2.2; use
       Repository.get_inventory() instead. (Matt Nordhoff, #528194)
 
-    - Ignore readonly+ prefix when checking if Loggerhead is serving a
-      local location. (Reported by Tres Seaver.) (Matt Nordhoff)
-
-    - Set Cache-Control and Expires headers on static pages.
-      (John Arbash Meinel)
-
-    - Generate relative links where possible (everywhere but HTTP
-      redirects and feed IDs). (Michael Hudson, Matt Nordhoff)
-
-    - Fix bad redirect when visiting "/download" or "/download/".
-      (Matt Nordhoff, #247992)
-
-
 1.17 [20Aug2009]
-----------------
+---------------
 
     - Add bug links in revision informations (Alexandre Garnier, #314052)
 
@@ -151,7 +120,7 @@
 
     - Fix a file descriptor leak (Matt Nordhoff, #370845)
 
-    - Use transport API internally, so it is possible to specify a remote
+    - Use transport API internally, so it is possible to specify a remote 
       URL to serve-branches. (Jelmer Vernooij, #371787)
 
     - Fix internal server errors when using start-loggerhead. (Matt
@@ -200,7 +169,7 @@
 
 
 1.10 [22Dec2008]
-----------------
+---------------
 
     - Add startup deamon script for Linux (Marius Kruger)
 

=== modified file 'README'
--- README	2010-04-13 23:35:01 +0000
+++ README	2009-11-27 18:06:53 +0000
@@ -1,28 +1,127 @@
-Loggerhead
+LOGGERHEAD
 ==========
 
-Overview
---------
-
-Loggerhead is a web viewer for Bazaar branches. Its lets users do
-stuff like:
-
-* navigate through branch history
-* view the files in a given revision
-* annotate files (i.e. find out the origin of each line of a file)
-* perform searches.
-
-
-Documentation
--------------
-
-See docs/index.rst for installation instructions and basic
-documentation.
-
-
-Licensing
----------
-
-This software is (C) Copyright Canonical Limited 2006-10 under the
-GPL Version 2 or later. Please see the file COPYING.txt for the
-licence details.
+[ Version 1.17 for Bazaar 1.17 ]
+
+Loggerhead is a web viewer for Bazaar branches.  It can be used to
+navigate a branch history, annotate files, perform searches... all the
+usual things.
+
+
+GETTING STARTED
+---------------
+
+Loggerhead depends on:
+
+1) SimpleTAL for templating.
+   On Ubuntu, `sudo apt-get install python-simpletal`
+   or download from http://www.owlfish.com/software/simpleTAL/download.html
+2) simplejson for producing JSON data.
+   On Ubuntu, `sudo apt-get install python-simplejson`
+   or use `easy_install simplejson`.
+3) Paste for the server. (You need version 1.2 or newer of Paste.)
+   On Ubuntu, `sudo apt-get install python-paste`
+   or use `easy_install Paste`
+4) Paste Deploy  (optional, needed when proxying through Apache)
+   On Ubuntu, `sudo apt-get install python-pastedeploy`
+   or use `easy_install PasteDeploy`
+5) flup (optional, needed to use FastCGI, SCGI or AJP)
+   On Ubuntu, `sudo apt-get install python-flup`
+   or use `easy_install flup`
+
+Then simply run the 'serve-branches' with the branch you want to
+serve on the command line:
+
+    ./serve-branches ~/path/to/branch
+
+The script listens on port 8080 so head to http://localhost:8080/ in
+your browser to see the branch.  You can also pass a directory that
+contains branches to the script, and it will serve a very simple
+directory listing at other pages.
+
+You may update the Bazaar branches being viewed at any time.
+Loggerhead will notice and refresh, and Bazaar uses its own branch
+locking to prevent corruption.
+
+To run loggerhead as a linux daemon:
+1) Copy loggerheadd to /etc/init.d
+2) Edit the file to configure where your loggerhead is installed, and which
+   serve-branches options you would like.
+3) Register the service
+   cd /etc/init.d
+   a) on upstart based systems like Ubuntu run: 
+      update-rc.d loggerheadd defaults
+   b) on Sysvinit based systems like Centos or SuSE run:
+      chkconfig --add loggerheadd
+
+
+LOGGERHEAD AS A BAZAAR PLUGIN
+-----------------------------
+
+This branch contains experimental support for using Loggerhead as a Bazaar
+plugin.  To use it, place the top-level Loggerhead directory (the one
+containing this file) at ``~/.bazaar/plugins/loggerhead``.
+
+
+USING A CONFIG FILE
+-------------------
+
+To hide branches from being displayed, add to ``~/.bazaar/locations.conf``,
+under the branch's section:
+
+    [/path/to/branch]
+    http_serve = False
+
+
+More configuration options to come soon.
+
+
+SERVING LOGGERHEAD FROM BEHIND APACHE
+-------------------------------------
+
+If you want to view Bazaar branches from your existing Apache
+installation, you'll need to configure Apache to proxy certain
+requests to Loggerhead.  Adding lines like this to you Apache
+configuration is one way to do this::
+
+    <Location "/branches/">
+        ProxyPass http://127.0.0.1:8080/branches/
+        ProxyPassReverse http://127.0.0.1:8080/branches/
+    </Location>
+
+If Paste Deploy is installed, the 'serve-branches' script can be
+run behind a proxy at the root of a site, but if you're running it at
+some path into the site, you'll need to specify is using '--prefix=/some_path'.
+
+
+SEARCH
+------
+
+Search is currently supported by using the bzr-search plugin (available
+at: ``https://launchpad.net/bzr-search``
+You need to have the plugin installed and each branch indexed to allow
+searching on branches.
+
+
+SUPPORT
+-------
+
+Loggerhead is loosely based on bazaar-webserve, which was loosely
+based on hgweb.  Discussion should take place on the bazaar-dev
+mailing list at bazaar@lists.canonical.com.  You can join the list at
+<https://lists.ubuntu.com/mailman/listinfo/bazaar>.  You don't need to
+subscribe to post, but your first post will be held briefly for manual
+moderation.
+
+Bugs are tracked on Launchpad; start at:
+
+    https://bugs.launchpad.net/loggerhead
+
+
+HACKING
+-------
+
+To run loggerhead tests, you will need the package python-nose,
+and run in the loggerhead directory:
+
+    nosetests

=== modified file '__init__.py'
--- __init__.py	2010-11-11 02:48:30 +0000
+++ __init__.py	2009-10-17 06:35:33 +0000
@@ -1,4 +1,4 @@
-# Copyright 2009, 2010 Canonical Ltd
+# Copyright 2009 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -26,20 +26,19 @@
 
 """Loggerhead web viewer for Bazaar branches.
 
-This provides a new option "--http" to the "bzr serve" command, that
+This provides a new option "--http" to the "bzr serve" command, that 
 starts a web server to browse the contents of a branch.
 """
 
-from info import (
-    bzr_plugin_version as version_info,
-    bzr_compatible_versions,
-    )
+version_info = (1, 17, 0)
 
 if __name__ == 'bzrlib.plugins.loggerhead':
     import bzrlib
     from bzrlib.api import require_any_api
 
-    require_any_api(bzrlib, bzr_compatible_versions)
+    require_any_api(bzrlib, [
+        (1, 13, 0), (1, 15, 0), (1, 16, 0), (1, 17, 0), (1, 18, 0),
+        (2, 0, 0), (2, 1, 0)])
 
     # NB: Normally plugins should lazily load almost everything, but this
     # seems reasonable to have in-line here: bzrlib.commands and options are
@@ -59,34 +58,18 @@
     HELP = ('Loggerhead, a web-based code viewer and server. (default port: %d)' %
             (DEFAULT_PORT,))
 
-    def setup_logging(config):
-        import logging
-        import sys
-
-        logger = logging.getLogger('loggerhead')
-        handler = logging.StreamHandler(sys.stderr)
-        handler.setLevel(logging.DEBUG)
-        logger.addHandler(handler)
-        logging.getLogger('simpleTAL').addHandler(handler)
-        logging.getLogger('simpleTALES').addHandler(handler)
-
-
-    def _ensure_loggerhead_path():
-        """Ensure that you can 'import loggerhead' and get the root."""
+    def serve_http(transport, host=None, port=None, inet=None):
+        from paste.httpexceptions import HTTPExceptionHandler
+        from paste.httpserver import serve
+
         # loggerhead internal code will try to 'import loggerhead', so
         # let's put it on the path if we can't find it in the existing path
         try:
-            import loggerhead.apps.transport
+            import loggerhead
         except ImportError:
             import os.path, sys
             sys.path.append(os.path.dirname(__file__))
 
-    def serve_http(transport, host=None, port=None, inet=None):
-        from paste.httpexceptions import HTTPExceptionHandler
-        from paste.httpserver import serve
-
-        _ensure_loggerhead_path()
-
         from loggerhead.apps.transport import BranchesFromTransportRoot
         from loggerhead.config import LoggerheadConfig
 
@@ -98,7 +81,6 @@
         if not transport.is_readonly():
             argv.insert(0, '--allow-writes')
         config = LoggerheadConfig(argv)
-        setup_logging(config)
         app = BranchesFromTransportRoot(transport.base, config)
         app = HTTPExceptionHandler(app)
         serve(app, host=host, port=port)
@@ -138,9 +120,3 @@
                     super(cmd_serve, self).run(*args, **kw)
 
         register_command(cmd_serve)
-
-    def load_tests(standard_tests, module, loader):
-        _ensure_loggerhead_path()
-        standard_tests.addTests(loader.loadTestsFromModuleNames(
-            ['bzrlib.plugins.loggerhead.loggerhead.tests']))
-        return standard_tests

=== modified file 'docs/conf.py'
--- docs/conf.py	2010-03-25 10:25:13 +0000
+++ docs/conf.py	2010-03-23 15:44:51 +0000
@@ -37,7 +37,7 @@
 master_doc = 'index'
 
 # General information about the project.
-project = u'Loggerhead'
+project = u'loggerhead'
 copyright = u'2010, Loggerhead team (https://launchpad.net/~loggerhead-team)'
 
 # The version info for the project you're documenting, acts as replacement for
@@ -172,7 +172,7 @@
 # Grouping the document tree into LaTeX files. List of tuples
 # (source start file, target name, title, author, documentclass [howto/manual]).
 latex_documents = [
-  ('index', 'loggerhead.tex', u'Loggerhead Documentation',
+  ('index', 'loggerhead.tex', u'loggerhead Documentation',
    u'Loggerhead team (https://launchpad.net/\\textasciitilde{}loggerhead-team)', 'manual'),
 ]
 

=== modified file 'docs/index.rst'
--- docs/index.rst	2010-04-13 08:46:25 +0000
+++ docs/index.rst	2010-03-23 20:10:11 +0000
@@ -1,9 +1,9 @@
-Loggerhead:  A web viewer for ``bzr`` branches
+loggerhead:  A web viewer for ``bzr`` branches
 ==============================================
 
-Loggerhead is a web viewer for projects in Bazaar. It can be used to navigate 
+Loggerhead is a web viewer for projects in bazaar. It can be used to navigate 
 a branch history, annotate files, view patches, perform searches, etc.
-Loggerhead is heavily based on `bazaar-webserve
+oggerhead is heavily based on `bazaar-webserve
 <https://launchpad.net/bzr-webserve>`_, which was, in turn, loosely
 based on `hgweb <http://mercurial.selenic.com/wiki/HgWebDirStepByStep>`_.
 
@@ -17,11 +17,11 @@
 
 - simplejson for producing JSON data.
 
-- Paste for the server. (You need version 1.2 or newer of Paste).
-
-- Paste Deploy  (optional, needed when proxying through Apache).
-
-- flup (optional, needed to use FastCGI, SCGI or AJP).
+- Paste for the server. (You need version 1.2 or newer of Paste.)
+
+- Paste Deploy  (optional, needed when proxying through Apache)
+
+- flup (optional, needed to use FastCGI, SCGI or AJP)
 
 
 Installing Dependencies Using Ubuntu Packages
@@ -75,7 +75,7 @@
 Running Loggerhead as a Daemon
 ------------------------------
 
-To run Loggerhead as a linux daemon:
+To run loggerhead as a linux daemon:
 
 1) Copy the ``loggerheadd`` scipt to ``/etc/init.d``
 
@@ -83,7 +83,7 @@
 
    $ sudo cp ./loggerheadd /etc/init.d
 
-2) Edit the file to configure where your Loggerhead is installed, and which
+2) Edit the file to configure where your loggerhead is installed, and which
    serve-branches options you would like.
 
 .. code-block:: sh
@@ -92,12 +92,16 @@
 
 3) Register the service
 
+a) on upstart based systems like Ubuntu run: 
+
 .. code-block:: sh
 
-   # on upstart based systems like Ubuntu run: 
    $ sudo update-rc.d loggerheadd defaults
 
-   # on Sysvinit based systems like Centos or SuSE run:
+b) on Sysvinit based systems like Centos or SuSE run:
+
+.. code-block:: sh
+
    $ sudo chkconfig --add loggerheadd
 
 
@@ -106,7 +110,7 @@
 
 This branch contains experimental support for using Loggerhead as a Bazaar
 plugin.  To use it, place the top-level Loggerhead directory (the one
-containing COPYING.txt) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
+containing this file) at ``~/.bazaar/plugins/loggerhead``.  E.g.:
 
 .. code-block:: sh
 
@@ -129,12 +133,12 @@
 More configuration options to come soon.
 
 
-Serving Loggerhead behind Apache
---------------------------------
+Serving Loggerhead from Behind Apache
+-------------------------------------
 
 If you want to view Bazaar branches from your existing Apache
 installation, you'll need to configure Apache to proxy certain
-requests to Loggerhead.  Adding lines like this to your Apache
+requests to Loggerhead.  Adding lines like this to you Apache
 configuration is one way to do this:
 
 .. code-block:: apache
@@ -146,7 +150,7 @@
 
 If Paste Deploy is installed, the :command:`serve-branches` script can be
 run behind a proxy at the root of a site, but if you're running it at
-some path into the site, you'll need to specify it using
+some path into the site, you'll need to specify is using
 ``--prefix=/some_path``.
 
 
@@ -159,8 +163,8 @@
 You need to have the plugin installed and each branch indexed to allow
 searching on branches.
 
-Command-Line Reference
-----------------------
+Script Reference
+----------------
 
 .. toctree::
    :maxdepth: 2
@@ -179,7 +183,7 @@
 subscribe to post, but your first post will be held briefly for manual
 moderation.
 
-Bugs, support questions and merge proposals are tracked on Launchpad, e.g:
+Bugs are tracked on Launchpad; start at:
 
     https://bugs.launchpad.net/loggerhead
 
@@ -187,8 +191,8 @@
 Hacking
 -------
 
-To run Loggerhead tests, you will need to install the package ``python-nose``,
-and run its :command:`nosetests` script in the Loggerhead directory:
+To run loggerhead tests, you will need to install the package ``python-nose``,
+and run its :command:`nosetests` script in the loggerhead directory:
 
 .. code-block:: sh
 

=== modified file 'docs/serve-branches.rst'
--- docs/serve-branches.rst	2010-03-25 10:32:47 +0000
+++ docs/serve-branches.rst	2010-03-23 19:54:47 +0000
@@ -1,7 +1,7 @@
 :command:`serve-branches`
 =========================
 
-The :command:`serve-branches` script runs a standalone Loggerhead server in
+The :command:`serve-branches` script runs a standalone loggerhead server in
 the foreground.
 
 .. program:: serve-branches
@@ -60,7 +60,7 @@
 
 .. cmdoption:: --log-folder=LOG_FOLDER
 
-    The directory in which to place Loggerhead's log files.
+    The directory in which to place loggerhead's log files.
     
     Defaults to the current directory.
 
@@ -78,10 +78,9 @@
    
     Allow writing to the Bazaar server.
     
-    Setting this option keeps Loggerhead from adding a 'readonly+' prefix
-    to the base URL of the branch.  The only effect of suppressing this prefix
-    is to make visible the display of instructions for checking out the
-    'public_branch' URL for the branch being browsed.
+    Setting this option keeps loggerhead from adding a 'readonly+' prefix
+    to the base URL of is to make visible the display of instructions for
+    checking out the 'public_branch' URL for the branch being browsed.
 
 .. cmdoption:: -h, --help
 

=== modified file 'docs/start-loggerhead.rst'
--- docs/start-loggerhead.rst	2010-03-25 10:39:30 +0000
+++ docs/start-loggerhead.rst	2010-03-23 19:54:47 +0000
@@ -1,7 +1,7 @@
 :command:`start-loggerhead`
 ===========================
 
-The :command:`start-loggerhead` command starts a new standalone Loggerhead
+The :command:`start-loggerhead` command starts a new standalone loggerhead
 server.  By default, the server runs in the background (daemonized).
 
 .. program:: start-loggerhead
@@ -11,7 +11,7 @@
 
 .. code-block:: sh
 
-    start-loggerhead [OPTIONS]
+   start-loggerhead [OPTIONS]
 
 Options
 -------
@@ -22,7 +22,7 @@
 
 .. cmdoption:: -h, --help
 
-    Show this help message and exit.
+    Show this help message and exit
 
 .. cmdoption:: --foreground
 
@@ -30,17 +30,17 @@
 
 .. cmdoption:: -C, --check
 
-    Only start if not already running (useful for cron jobs).
+    Only start if not already running (useful for cron jobs)
 
 .. cmdoption:: -p, --pidfile=PIDFILE
 
-    Override pid file location.
+    override pid file location
 
 .. cmdoption:: -c, --config-file=CONFIGFILE
 
-    Override configuration file location (the default is
-    :file:`/etc/loggerhead.conf`).
+   Override configuration file location [XXX default is
+   :file:`/etc/loggerhead.conf`]
 
 .. cmdoption:: --log-folder=LOG_FOLDER
 
-    The directory in which to place log files.
+    The directory [XXX in which] to place log files

=== modified file 'docs/stop-loggerhead.rst'
--- docs/stop-loggerhead.rst	2010-03-25 10:25:13 +0000
+++ docs/stop-loggerhead.rst	2010-03-23 19:54:47 +0000
@@ -1,7 +1,7 @@
 :command:`stop-loggerhead`
 ======================================================================
 
-The :command:`stop-loggerhead` command stops the currently running Loggerhead
+The :command:`stop-loggerhead` command stops the currently running loggerhead
 daemon.
 
 .. program:: stop-loggerhead

=== removed file 'info.py'
--- info.py	2010-11-11 03:30:43 +0000
+++ info.py	1970-01-01 00:00:00 +0000
@@ -1,13 +0,0 @@
-#!/usr/bin/env python
-# API Info for loggerhead
-
-bzr_plugin_name = "loggerhead"
-
-bzr_plugin_version = (1, 18, 0)
-
-bzr_compatible_versions = [
-    (1, 17, 0), (1, 18, 0), (2, 0, 0), (2, 1, 0), (2, 2, 0), (2, 3, 0)]
-
-bzr_minimum_version = bzr_compatible_versions[0]
-
-bzr_maximum_version = bzr_compatible_versions[-1]

=== modified file 'loggerhead.conf.example'
--- loggerhead.conf.example	2009-10-17 09:28:42 +0000
+++ loggerhead.conf.example	2008-07-22 00:40:03 +0000
@@ -23,7 +23,7 @@
 
     # name of this project
     name = 'bazaar'
-
+    
     # for the top browsing page, you can include a description, in raw HTML.
     #description = 'Bazaar is a <i>revision control system</i>.'
 
@@ -63,13 +63,13 @@
 [paramiko]
     name = 'paramiko'
     cachepath = '/Users/robey/code/paramiko/.bzr/loggerhead-files'
-
+    
     # if an auto_publish_folder is given, any bazaar branches discovered in
     # that folder will be published.  using each branch's 'branch.conf' to
     # provide optional descriptions and public urls is a nice way to avoid
     # having to do much configuration here.
     auto_publish_folder = '/Users/robey/code/paramiko'
-
+    
     # if all of the branches under an auto_publish_folder are exported to
     # the same (base) public url, you can specify that url prefix here, and
     # each discovered branch's public url will be generated.

=== modified file 'loggerhead/__init__.py'
--- loggerhead/__init__.py	2011-03-24 03:40:33 +0000
+++ loggerhead/__init__.py	2009-08-20 13:30:37 +0000
@@ -22,7 +22,7 @@
 
 import pkg_resources
 
-__version__ = '1.18.1'
+__version__ = '1.17'
 required_bzrlib = (1, 17)
 
 pkg_resources.get_distribution('Paste>=1.6')

=== modified file 'loggerhead/apps/__init__.py'
--- loggerhead/apps/__init__.py	2010-04-30 21:30:18 +0000
+++ loggerhead/apps/__init__.py	2009-11-26 03:44:40 +0000
@@ -9,9 +9,7 @@
 static = os.path.join(
     os.path.dirname(os.path.dirname(__file__)), 'static')
 
-# Static things can be cached for half a day, we could probably make this
-# longer, except for just before rollout times.
-static_app = urlparser.make_static(None, static, cache_max_age=12*60*60)
+static_app = urlparser.make_static(None, static)
 
 favicon_app = convert_file_errors(fileapp.FileApp(
     os.path.join(static, 'images', 'favicon.ico')))

=== modified file 'loggerhead/apps/branch.py'
--- loggerhead/apps/branch.py	2010-05-05 18:28:54 +0000
+++ loggerhead/apps/branch.py	2009-10-17 06:35:33 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2008, 2009, 2010 Canonical Ltd.
+# Copyright (C) 2008, 2009 Canonical Ltd.
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,7 +21,6 @@
 import sys
 
 import bzrlib.branch
-import bzrlib.errors
 import bzrlib.lru_cache
 
 from paste import request
@@ -89,15 +88,10 @@
             if v is not None:
                 qs.append('%s=%s' % (k, urllib.quote(v)))
         qs = '&'.join(qs)
-        path_info = urllib.quote(
-            unicode('/'.join(args)).encode('utf-8'), safe='/~:')
-        if qs:
-            path_info += '?' + qs
-        return self._url_base + path_info
-
-    def absolute_url(self, *args, **kw):
-        rel_url = self.url(*args, **kw)
-        return request.resolve_relative_url(rel_url, self._environ)
+        return request.construct_url(
+            self._environ, script_name=self._url_base,
+            path_info=unicode('/'.join(args)).encode('utf-8'),
+            querystring=qs)
 
     def context_url(self, *args, **kw):
         kw = util.get_context(**kw)
@@ -151,15 +145,14 @@
             else:
                 # Loggerhead only supports serving .bzr/ on local branches, so
                 # we shouldn't suggest something that won't work.
-                try:
-                    util.local_path_from_url(self.branch.base)
+                if self.branch.base.startswith('file://'):
                     self.served_url = self.url([])
-                except bzrlib.errors.InvalidURL:
+                else:
                     self.served_url = None
         path = request.path_info_pop(environ)
         if not path:
             raise httpexceptions.HTTPMovedPermanently(
-                self.absolute_url('/changes'))
+                self._url_base + '/changes')
         if path == 'static':
             return static_app(environ, start_response)
         cls = self.controllers_dict.get(path)

=== modified file 'loggerhead/apps/config.py'
--- loggerhead/apps/config.py	2010-05-05 18:35:35 +0000
+++ loggerhead/apps/config.py	2009-05-13 13:14:04 +0000
@@ -208,8 +208,8 @@
                                 environ['SCRIPT_NAME']
         segment = path_info_pop(environ)
         if segment is None:
-            raise httpexceptions.HTTPMovedPermanently.relative_redirect(
-                environ['SCRIPT_NAME'] + '/', environ)
+            raise httpexceptions.HTTPMovedPermanently(
+                environ['SCRIPT_NAME'] + '/')
         elif segment == '':
             response = WSGIResponse()
             self.browse(response)

=== modified file 'loggerhead/apps/transport.py'
--- loggerhead/apps/transport.py	2010-05-05 18:35:35 +0000
+++ loggerhead/apps/transport.py	2009-11-26 03:20:53 +0000
@@ -28,12 +28,10 @@
 from paste import httpexceptions
 from paste import urlparser
 
-from loggerhead import util
 from loggerhead.apps.branch import BranchWSGIApp
 from loggerhead.apps import favicon_app, robots_app, static_app
 from loggerhead.controllers.directory_ui import DirectoryUI
 
-# TODO: Use bzrlib.ui.bool_from_string(), added in bzr 1.18
 _bools = {
     'yes': True, 'no': False,
     'on': True, 'off': False,
@@ -69,8 +67,8 @@
     def app_for_non_branch(self, environ):
         segment = path_info_pop(environ)
         if segment is None:
-            raise httpexceptions.HTTPMovedPermanently.relative_redirect(
-                environ['SCRIPT_NAME'] + '/', environ)
+            raise httpexceptions.HTTPMovedPermanently(
+                environ['SCRIPT_NAME'] + '/')
         elif segment == '':
             if self.name:
                 name = self.name
@@ -95,8 +93,11 @@
             # TODO: Use something here that uses the transport API
             # rather than relying on the local filesystem API.
             base = self.transport.base
+            readonly_prefix = 'readonly+'
+            if base.startswith(readonly_prefix):
+                base = base[len(readonly_prefix):]
             try:
-                path = util.local_path_from_url(base)
+                path = urlutils.local_path_from_url(base)
             except errors.InvalidURL:
                 raise httpexceptions.HTTPNotFound()
             else:

=== modified file 'loggerhead/config.py'
--- loggerhead/config.py	2010-04-13 23:35:01 +0000
+++ loggerhead/config.py	2009-11-23 22:45:46 +0000
@@ -87,7 +87,7 @@
         self.SQL_DIR = sql_dir
 
     def get_option(self, option):
-        """Get the value for the config option, either
+        """Get the value for the config option, either 
         from ~/.bazaar/bazaar.conf or from the command line.
         All loggerhead-specific settings start with 'http_'
         """

=== modified file 'loggerhead/controllers/annotate_ui.py'
--- loggerhead/controllers/annotate_ui.py	2011-03-24 01:27:03 +0000
+++ loggerhead/controllers/annotate_ui.py	2009-10-17 06:35:33 +0000
@@ -17,6 +17,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cgi
 import os
 import time
 
@@ -70,7 +71,7 @@
                 hl_lines = highlight(file_name, file_text, encoding)
                 hl_lines.extend([u''] * (len(file_lines) - len(hl_lines)))
             else:
-                hl_lines = map(util.html_escape, file_lines)
+                hl_lines = map(cgi.escape, file_lines)
 
             change_cache = {}
 

=== modified file 'loggerhead/controllers/changelog_ui.py'
--- loggerhead/controllers/changelog_ui.py	2010-04-22 08:52:59 +0000
+++ loggerhead/controllers/changelog_ui.py	2009-06-25 03:35:43 +0000
@@ -106,7 +106,7 @@
             'navigation': navigation,
             'filter_file_id': filter_file_id,
             'start_revid': start_revid,
-            'viewing_from': (orig_start_revid is not None) and
+            'viewing_from': (orig_start_revid is not None) and 
                             (orig_start_revid != history.last_revid),
             'query': query,
             'search_failed': search_failed,

=== modified file 'loggerhead/controllers/diff_ui.py'
--- loggerhead/controllers/diff_ui.py	2010-04-08 01:08:33 +0000
+++ loggerhead/controllers/diff_ui.py	2009-10-17 08:59:33 +0000
@@ -72,7 +72,7 @@
         filename = '%s_%s.diff' % (revno1, revno2)
         headers = [
             ('Content-Type', 'application/octet-stream'),
-            ('Content-Length', str(len(content))),
+            ('Content-Length', len(content)),
             ('Content-Disposition', 'attachment; filename=%s' % (filename,)),
             ]
         start_response('200 OK', headers)

=== modified file 'loggerhead/controllers/download_ui.py'
--- loggerhead/controllers/download_ui.py	2010-05-05 19:03:40 +0000
+++ loggerhead/controllers/download_ui.py	2009-10-17 09:21:55 +0000
@@ -44,8 +44,8 @@
             args.append(arg)
 
         if len(args) < 2:
-            raise httpexceptions.HTTPMovedPermanently(
-                self._branch.absolute_url('/changes'))
+            raise httpexceptions.HTTPMovedPermanently(self._branch.url(
+                      '../changes'))
 
         revid = h.fix_revid(args[0])
         file_id = args[1]
@@ -61,7 +61,7 @@
         encoded_filename = urllib.quote(filename.encode('utf-8'))
         headers = [
             ('Content-Type', mime_type),
-            ('Content-Length', str(len(content))),
+            ('Content-Length', len(content)),
             ('Content-Disposition',
              "attachment; filename*=utf-8''%s" % (encoded_filename,)),
             ]

=== modified file 'loggerhead/highlight.py'
--- loggerhead/highlight.py	2010-04-22 03:23:55 +0000
+++ loggerhead/highlight.py	2009-05-16 06:03:47 +0000
@@ -16,8 +16,6 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
-import cgi
-
 from pygments import highlight as _highlight_func
 from pygments.lexers import guess_lexer, guess_lexer_for_filename, TextLexer
 from pygments.formatters import HtmlFormatter
@@ -25,19 +23,12 @@
 
 DEFAULT_PYGMENT_STYLE = 'colorful'
 
-# Trying to highlight very large files using pygments was killing
-# loggerhead on launchpad.net, because pygments isn't very fast.
-# So we only highlight files if they're 512K or smaller.
-MAX_HIGHLIGHT_SIZE = 512000;
 
 def highlight(path, text, encoding, style=DEFAULT_PYGMENT_STYLE):
     """
     Returns a list of highlighted (i.e. HTML formatted) strings.
     """
 
-    if len(text) > MAX_HIGHLIGHT_SIZE:
-        return map(cgi.escape, text.split('\n'))
-
     formatter = HtmlFormatter(style=style, nowrap=True, classprefix='pyg-')
 
     try:

=== modified file 'loggerhead/history.py'
--- loggerhead/history.py	2010-05-04 02:22:15 +0000
+++ loggerhead/history.py	2010-02-26 04:37:13 +0000
@@ -152,9 +152,6 @@
                 filename=rich_filename(paths[1], kind),
                 file_id=file_id))
 
-# The lru_cache is not thread-safe, so we need a lock around it for
-# all threads.
-rev_info_memory_cache_lock = threading.RLock()
 
 class RevInfoMemoryCache(object):
     """A store that validates values against the revids they were stored with.
@@ -178,11 +175,7 @@
         If a value was stored under `key`, with the same revid, return it.
         Otherwise return None.
         """
-        rev_info_memory_cache_lock.acquire()
-        try:
-            cached = self._cache.get(key)
-        finally:
-            rev_info_memory_cache_lock.release()
+        cached = self._cache.get(key)
         if cached is None:
             return None
         stored_revid, data = cached
@@ -194,11 +187,7 @@
     def set(self, key, revid, data):
         """Store `data` under `key`, to be checked against `revid` on get().
         """
-        rev_info_memory_cache_lock.acquire()
-        try:
-            self._cache[key] = (revid, data)
-        finally:
-            rev_info_memory_cache_lock.release()
+        self._cache[key] = (revid, data)
 
 # Used to store locks that prevent multiple threads from building a 
 # revision graph for the same branch at the same time, because that can
@@ -294,7 +283,6 @@
         else:
             self._file_change_cache = None
         self._branch = branch
-        self._branch_tags = None
         self._inventory_cache = {}
         self._branch_nick = self._branch.get_config().get_nickname()
         self.log = logging.getLogger('loggerhead.%s' % (self._branch_nick,))
@@ -665,12 +653,11 @@
         """
         message, short_message = clean_message(revision.message)
 
-        if self._branch_tags is None:
-            self._branch_tags = self._branch.tags.get_reverse_tag_dict()
+        tags = self._branch.tags.get_reverse_tag_dict()
 
         revtags = None
-        if revision.revision_id in self._branch_tags:
-          revtags = ', '.join(self._branch_tags[revision.revision_id])
+        if tags.has_key(revision.revision_id):
+          revtags = ', '.join(tags[revision.revision_id])
 
         entry = {
             'revid': revision.revision_id,

=== modified file 'loggerhead/static/css/annotate.css'
--- loggerhead/static/css/annotate.css	2009-04-30 10:39:05 +0000
+++ loggerhead/static/css/annotate.css	2009-03-01 20:57:52 +0000
@@ -4,7 +4,7 @@
 	border:1px solid #d2d2d2;
 }
 .annoLine, .annoRev, .annoComm, .annoCont {
-	border:none;
+	border:none;	
 }
 .annoLine {
 	width:37px;

=== modified file 'loggerhead/static/css/global.css'
--- loggerhead/static/css/global.css	2009-10-17 06:55:25 +0000
+++ loggerhead/static/css/global.css	2009-06-11 21:16:27 +0000
@@ -180,7 +180,7 @@
 }
 #loggerheadCont p.expand, #loggerheadCont p.expand a, #loggerheadCont p.expand a:link, #loggerheadCont p.expand a:visited, #loggerheadCont p.expand a:hover {
 	color:#000;
-	text-decoration:none;
+	text-decoration:none;	
 }
 #loggerheadCont p img {
 	vertical-align:middle;
@@ -192,7 +192,7 @@
 }
 .revnolink a, .revnolink a:visited, .revnolink a:link, .revnolink a:hover {
 	color:#CC6600;
-	text-decoration:none;
+	text-decoration:none;		
 }
 
 /*Log Table*/
@@ -214,7 +214,7 @@
 }
 .blueRow0, .blueRow1 {
 	background:#eef6fa;
-	font:normal 14px/normal sans-serif;
+	font:normal 14px/normal sans-serif;	
 	padding:0px;
 	margin:0px;
 }
@@ -228,7 +228,7 @@
 	border:1px solid #d2d2d2;
 }
 .expandcell, .expcell {
-	width:28px;
+	width:28px;	
 }
 .summarycell, .authorcell, .tagscell, .datecell, .timedate{
   padding: 4px 8px;

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2011-03-24 01:27:03 +0000
+++ loggerhead/templatefunctions.py	2009-10-17 08:47:38 +0000
@@ -14,8 +14,8 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #
 
+import cgi
 import os
-import urllib
 
 import pkg_resources
 
@@ -23,7 +23,6 @@
 
 import loggerhead
 from loggerhead.zptsupport import zpt
-from loggerhead.util import html_format
 
 
 templatefunctions = {}
@@ -50,21 +49,16 @@
     if style == 'fragment':
         def file_link(filename):
             if currently_showing and filename == currently_showing:
-                return html_format(
-                    '<b><a href="#%s">%s</a></b>',
-                    urllib.quote(filename.encode('utf-8')), filename)
+                return '<b><a href="#%s">%s</a></b>' % (
+                    cgi.escape(filename), cgi.escape(filename))
             else:
                 return revision_link(
-                    url, entry.revno, filename,
-                    '#' + urllib.quote(filename.encode('utf-8')))
+                    url, entry.revno, filename, '#' + filename)
     else:
         def file_link(filename):
-            return html_format(
-                '<a href="%s%s" title="View changes to %s in revision %s">'
-                '%s</a>',
-                url(['/revision', entry.revno]),
-                '#' + urllib.quote(filename.encode('utf-8')),
-                filename, entry.revno, filename)
+            return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+                url(['/revision', entry.revno]), '#' + filename, cgi.escape(filename),
+                cgi.escape(entry.revno), cgi.escape(filename))
     return _pt('revisionfilechanges').expand(
         entry=entry, file_changes=file_changes, file_link=file_link, **templatefunctions)
 
@@ -128,16 +122,14 @@
 
 @templatefunc
 def annotate_link(url, revno, path):
-    return html_format(
-        '<a href="%s" title="Annotate %s">%s</a>',
-        url(['/annotate', revno, path]), path, path)
-
+    return '<a href="%s" title="Annotate %s">%s</a>' % (
+        url(['/annotate', revno, path]), cgi.escape(path), cgi.escape(path))
 
 @templatefunc
 def revision_link(url, revno, path, frag=''):
-    return html_format(
-        '<a href="%s%s" title="View changes to %s in revision %s">%s</a>',
-        url(['/revision', revno, path]), frag, path, revno, path)
+    return '<a href="%s%s" title="View changes to %s in revision %s">%s</a>' % (
+        url(['/revision', revno, path]), frag, cgi.escape(path),
+        cgi.escape(revno), cgi.escape(path))
 
 
 @templatefunc

=== modified file 'loggerhead/templates/annotate.pt'
--- loggerhead/templates/annotate.pt	2009-04-30 10:39:05 +0000
+++ loggerhead/templates/annotate.pt	2009-03-06 09:57:54 +0000
@@ -58,7 +58,7 @@
             <td class="annoContTit">Contents</td>
           </tr>
 
-          <tr tal:repeat="line contents"
+          <tr tal:repeat="line contents" 
               tal:attributes="class string:blueRow${line/parity}">
             <td class="annoLine"><a tal:attributes="id string:L${line/lineno}; href string:#L${line/lineno}" tal:content="line/lineno">1</a></td>
             <td class="annoRev">

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2010-05-05 18:42:58 +0000
+++ loggerhead/templates/atom.pt	2009-06-06 12:23:11 +0000
@@ -4,8 +4,8 @@
     bazaar changes for <tal:branch-name content="branch/friendly_name">branch name</tal:branch-name>
   </title>
   <updated tal:content="string:${updated}Z">${updated}</updated>
-  <id tal:content="python:branch.absolute_url(['/atom'])">url</id>
-  <link rel="self" type="application/atom+xml" tal:attributes="href python:branch.absolute_url(['/atom'])" />
+  <id tal:content="python:branch.url(['/atom'])">url</id>
+  <link rel="self" type="application/atom+xml" tal:attributes="href python:branch.url(['/atom'])" />
   <link rel="alternate" type="text/html" tal:attributes="href python:branch.url(['/changes'])" />
 
   <entry tal:repeat="entry changes">
@@ -16,7 +16,7 @@
       updated
     </updated>
     <!-- TODO: The feed validator will generate warnings because this is URL-encoded -->
-    <id tal:content="python:branch.absolute_url(['/revision', entry.revno])">
+    <id tal:content="python:branch.url(['/revision', entry.revno])">
       ID
     </id>
     <author tal:repeat="author entry/authors">

=== modified file 'loggerhead/templates/browse.pt'
--- loggerhead/templates/browse.pt	2009-10-17 06:55:25 +0000
+++ loggerhead/templates/browse.pt	2009-05-13 13:14:04 +0000
@@ -28,7 +28,7 @@
                   <img tal:attributes="src python:branch.static_url('/static/images/ico_branch.gif')" alt="Branch" />
                 </td>
                 <td class="autcell">
-                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)"
+                    <a tal:attributes="href python:branch.static_url(project.name + '/' +  view.name)" 
                        tal:content="view/friendly_name" />
                 </td>
                 <td class="autcell"

=== modified file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2010-04-13 23:35:01 +0000
+++ loggerhead/templates/directory.pt	2009-11-27 00:14:35 +0000
@@ -19,7 +19,7 @@
             <th class="datecell">Latest Rev</th>
             <th class="datecell">Last Changed</th>
           </tr>
-
+          
           <tr class="blueRow0" tal:condition="python:name != '/'">
             <td class="icocell">
                 <a href="../"><img tal:attributes="src python:static_url('/static/images/ico_folder_up.gif')" /></a>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2009-10-17 06:55:25 +0000
+++ loggerhead/templates/inventory.pt	2009-07-15 22:02:09 +0000
@@ -70,7 +70,7 @@
                                              title string:Go to ${file/filename}" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])"
+                 <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])" 
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -93,7 +93,7 @@
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file_flecha.gif')" alt="Symlink" />
                     </a>
 
-                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])"
+                 <a tal:attributes="href python:url(['/annotate', revno_url, file.absolutepath])" 
                                         tal:content="file/filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
@@ -118,7 +118,7 @@
                                              title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is False" />
                         <!-- Show a different icon id the file executable -->
-                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif');
+                        <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif'); 
                                              title string:Annotate ${file/filename}"
                              tal:condition="python:file.executable is True" alt="File" />
                     </a>

=== modified file 'loggerhead/tests/__init__.py'
--- loggerhead/tests/__init__.py	2011-03-24 01:27:03 +0000
+++ loggerhead/tests/__init__.py	2006-12-11 06:44:19 +0000
@@ -1,27 +0,0 @@
-# Copyright 2006, 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-def load_tests(standard_tests, module, loader):
-    standard_tests.addTests(loader.loadTestsFromModuleNames([
-        (__name__ + '.' + x) for x in [
-            'test_controllers',
-            'test_corners',
-            'test_simple',
-            'test_templating',
-            'test_util',
-        ]]))
-    return standard_tests

=== modified file 'loggerhead/tests/test_simple.py'
--- loggerhead/tests/test_simple.py	2011-03-24 01:27:03 +0000
+++ loggerhead/tests/test_simple.py	2009-06-08 23:02:49 +0000
@@ -59,11 +59,9 @@
 
         self.filecontents = ('some\nmultiline\ndata\n'
                              'with<htmlspecialchars\n')
-        filenames = ['myfilename', 'anotherfile<']
         self.build_tree_contents(
-            (filename, self.filecontents) for filename in filenames)
-        for filename in filenames:
-            self.tree.add(filename, '%s-id' % filename)
+            [('myfilename', self.filecontents)])
+        self.tree.add('myfilename')
         self.fileid = self.tree.path2id('myfilename')
         self.msg = 'a very exciting commit message <'
         self.revid = self.tree.commit(message=self.msg)
@@ -119,8 +117,6 @@
     def test_revision(self):
         app = self.setUpLoggerhead()
         res = app.get('/revision/1')
-        res.mustcontain(no=['anotherfile<'])
-        res.mustcontain('anotherfile&lt;')
         res.mustcontain('myfilename')
 
 

=== removed file 'loggerhead/tests/test_util.py'
--- loggerhead/tests/test_util.py	2011-03-24 01:27:03 +0000
+++ loggerhead/tests/test_util.py	1970-01-01 00:00:00 +0000
@@ -1,33 +0,0 @@
-# Copyright 2011 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib import tests
-
-from loggerhead.util import html_escape, html_format
-
-
-class TestHTMLEscaping(tests.TestCase):
-
-    def test_html_escape(self):
-        self.assertEqual(
-            "foo &quot;&#39;&lt;&gt;&amp;",
-            html_escape("foo \"'<>&"))
-
-    def test_html_format(self):
-        self.assertEqual(
-            '<foo bar="baz&quot;&#39;">&lt;baz&gt;&amp;</foo>',
-            html_format(
-                '<foo bar="%s">%s</foo>', "baz\"'", "<baz>&"))

=== modified file 'loggerhead/trace.py'
--- loggerhead/trace.py	2010-11-12 00:09:49 +0000
+++ loggerhead/trace.py	2008-10-24 02:26:05 +0000
@@ -22,7 +22,6 @@
 
 import os
 import logging
-import logging.handlers
 import sys
 
 

=== modified file 'loggerhead/util.py'
--- loggerhead/util.py	2011-03-24 01:27:03 +0000
+++ loggerhead/util.py	2009-11-26 03:44:40 +0000
@@ -20,6 +20,7 @@
 #
 
 import base64
+import cgi
 import datetime
 import logging
 import re
@@ -35,8 +36,6 @@
 except ImportError:
     from elementtree import ElementTree as ET
 
-from bzrlib import urlutils
-
 from simpletal.simpleTALUtils import HTMLStructureCleaner
 
 log = logging.getLogger("loggerhead.controllers")
@@ -67,7 +66,7 @@
 
 def date_time(value):
     if value is not None:
-        return value.strftime('%Y-%m-%d %H:%M:%S')
+        return value.strftime('%Y-%m-%d %T')
     else:
         return 'N/A'
 
@@ -136,7 +135,6 @@
     """
 
     def __init__(self, _dict=None, **kw):
-        self._properties = {}
         if _dict is not None:
             for key, value in _dict.iteritems():
                 setattr(self, key, value)
@@ -153,24 +151,6 @@
         out += '}'
         return out
 
-    def __getattr__(self, attr):
-        """Used for handling things that aren't already available."""
-        if attr.startswith('_') or attr not in self._properties:
-            raise AttributeError('No attribute: %s' % (attr,))
-        val = self._properties[attr](self, attr)
-        setattr(self, attr, val)
-        return val
-
-    def _set_property(self, attr, prop_func):
-        """Set a function that will be called when an attribute is desired.
-
-        We will cache the return value, so the function call should be
-        idempotent. We will pass 'self' and the 'attr' name when triggered.
-        """
-        if attr.startswith('_'):
-            raise ValueError("Cannot create properties that start with _")
-        self._properties[attr] = prop_func
-
 
 def trunc(text, limit=10):
     if len(text) <= limit:
@@ -213,47 +193,16 @@
 # only do this if unicode turns out to be a problem
 #_BADCHARS_RE = re.compile(ur'[\u007f-\uffff]')
 
-# Can't be a dict; &amp; needs to be done first.
-html_entity_subs = [
-    ("&", "&amp;"),
-    ('"', "&quot;"),
-    ("'", "&#39;"), # &apos; is defined in XML, but not HTML.
-    (">", "&gt;"),
-    ("<", "&lt;"),
-    ]
-
-
-def html_escape(s):
-    """Transform dangerous (X)HTML characters into entities.
-
-    Like cgi.escape, except also escaping " and '. This makes it safe to use
-    in both attribute and element content.
-
-    If you want to safely fill a format string with escaped values, use
-    html_format instead
-    """
-    for char, repl in html_entity_subs:
-        s = s.replace(char, repl)
-    return s
-
-
-def html_format(template, *args):
-    """Safely format an HTML template string, escaping the arguments.
-
-    The template string must not be user-controlled; it will not be escaped.
-    """
-    return template % tuple(html_escape(arg) for arg in args)
-
-
 # FIXME: get rid of this method; use fixed_width() and avoid XML().
 
+
 def html_clean(s):
     """
     clean up a string for html display.  expand any tabs, encode any html
     entities, and replace spaces with '&nbsp;'.  this is primarily for use
     in displaying monospace text.
     """
-    s = html_escape(s.expandtabs())
+    s = cgi.escape(s.expandtabs())
     s = s.replace(' ', '&nbsp;')
     return s
 
@@ -299,7 +248,7 @@
         except UnicodeDecodeError:
             s = s.decode('iso-8859-15')
 
-    s = html_escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
+    s = cgi.escape(s).expandtabs().replace(' ', NONBREAKING_SPACE)
 
     return HSC.clean(s).replace('\n', '<br/>')
 
@@ -375,14 +324,6 @@
     return out
 
 
-def local_path_from_url(url):
-    """Convert Bazaar URL to local path, ignoring readonly+ prefix"""
-    readonly_prefix = 'readonly+'
-    if url.startswith(readonly_prefix):
-        url = url[len(readonly_prefix):]
-    return urlutils.local_path_from_url(url)
-
-
 def fill_in_navigation(navigation):
     """
     given a navigation block (used by the template for the page header), fill

=== modified file 'loggerheadd'
--- loggerheadd	2009-04-30 10:39:05 +0000
+++ loggerheadd	2008-11-24 20:26:26 +0000
@@ -16,9 +16,9 @@
 
 LHUSER=loggerhead
 
-if [ `whoami` = "$LHUSER" ]; then
+if [ `whoami` = "$LHUSER" ]; then                                                                                   
     SUDO=""
-else
+else                                                                                                                
     SUDO="sudo -H -u $LHUSER"
 fi
 

